
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class QuizzesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quizzes = await db.quizzes.create(
            {
                id: data.id || undefined,
        
        quiz_title: data.quiz_title
        ||
        null
            ,
            
        grading_method: data.grading_method
        ||
        null
            ,
            
        passing_score: data.passing_score
        ||
        null
            ,
            
        shuffle_questions: data.shuffle_questions
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await quizzes.setMission( data.mission || null, {
            transaction,
        });
        
        await quizzes.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return quizzes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const quizzesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quiz_title: item.quiz_title
            ||
            null
            ,
            
                grading_method: item.grading_method
            ||
            null
            ,
            
                passing_score: item.passing_score
            ||
            null
            ,
            
                shuffle_questions: item.shuffle_questions
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const quizzes = await db.quizzes.bulkCreate(quizzesData, { transaction });

        // For each item created, replace relation files
        

        return quizzes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const quizzes = await db.quizzes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quiz_title !== undefined) updatePayload.quiz_title = data.quiz_title;
        
        
        if (data.grading_method !== undefined) updatePayload.grading_method = data.grading_method;
        
        
        if (data.passing_score !== undefined) updatePayload.passing_score = data.passing_score;
        
        
        if (data.shuffle_questions !== undefined) updatePayload.shuffle_questions = data.shuffle_questions;
        
        
        updatePayload.updatedById = currentUser.id;

        await quizzes.update(updatePayload, {transaction});

        
        
        if (data.mission !== undefined) {
            await quizzes.setMission(
              
              data.mission,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await quizzes.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return quizzes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quizzes = await db.quizzes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of quizzes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of quizzes) {
                await record.destroy({transaction});
            }
        });


        return quizzes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const quizzes = await db.quizzes.findByPk(id, options);

        await quizzes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await quizzes.destroy({
            transaction
        });

        return quizzes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const quizzes = await db.quizzes.findOne(
            { where },
            { transaction },
        );

        if (!quizzes) {
            return quizzes;
        }

        const output = quizzes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.quiz_questions_quiz = await quizzes.getQuiz_questions_quiz({
            transaction
        });
        
        
        
        output.quiz_submissions_quiz = await quizzes.getQuiz_submissions_quiz({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.mission = await quizzes.getMission({
            transaction
        });
        
        
        output.organizations = await quizzes.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.missions,
        as: 'mission',
        
        where: filter.mission ? {
          [Op.or]: [
            { id: { [Op.in]: filter.mission.split('|').map(term => Utils.uuid(term)) } },
            {
              mission_title: {
                [Op.or]: filter.mission.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.quiz_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quizzes',
                        'quiz_title',
                        filter.quiz_title,
                    ),
                };
            }
            

            
            

            
            if (filter.passing_scoreRange) {
                const [start, end] = filter.passing_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    passing_score: {
                    ...where.passing_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    passing_score: {
                    ...where.passing_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.grading_method) {
                where = {
                    ...where,
                grading_method: filter.grading_method,
            };
            }
            
            if (filter.shuffle_questions) {
                where = {
                    ...where,
                shuffle_questions: filter.shuffle_questions,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.quizzes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'quizzes',
                        'quiz_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.quizzes.findAll({
            attributes: [ 'id', 'quiz_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['quiz_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.quiz_title,
        }));
    }

    
};

